/***************************************************************************
 *   Copyright (C) 2002 by Bernd Gehrmann                                  *
 *   bernd@kdevelop.org                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _TEXTTOOLSWIDGET_H_
#define _TEXTTOOLSWIDGET_H_

#include <tdelistview.h>
#include <tqstringlist.h>

class TextToolsPart;
class TQTimer;
namespace KParts { class Part; }
namespace KTextEditor { class EditInterface; }


class TextToolsWidget : public TDEListView
{
    TQ_OBJECT
  

public:
    enum Mode { HTML, Docbook, LaTeX };
    
    TextToolsWidget( TextToolsPart *part, TQWidget *parent=0, const char *name=0 );
    ~TextToolsWidget();

    void setMode(Mode mode, KParts::Part *part);
    void stop();

private slots:
    void slotItemPressed(int button, TQListViewItem *item);
    void slotReturnPressed(TQListViewItem *item);
    void slotContextMenu(TDEListView *, TQListViewItem *item, const TQPoint &p);

    void startTimer();
    void parseXML();
    void parseLaTeX();

private:
    TextToolsPart *m_part;
    TQTimer *m_timer;
    TQString m_cachedText;
    KTextEditor::EditInterface *m_editIface;
    TQStringList m_relevantTags, m_emptyTags;
};

#endif
